/*****************************************

  This is a base class from which is derived
  the functions that go into TransX.

  */
#ifndef __MFDFUNCTION_H
#define __MFDFUNCTION_H

class MFDFunction
{
private:
	static MFDFunction *highactionarray[100];//High priority action array
	static MFDFunction *lowactionarray[30];//Low priority action array

	static int highread;//Keep track of array positions
	static int highwrite;
	static int lowread;
	static int lowwrite;

	bool allowedtowrite;//Only one lowaction outstanding per instance - use this to keep control of queues!

protected:
	bool valid;
	virtual void dolowpriaction(); //Overloaded to carry out processing task in background.
	virtual void dohighpriaction(); //Overloaded to carry out processing task in background
public:
	MFDFunction(); //Constructor
	virtual ~MFDFunction(); //Destructor
	bool isvalid();
	virtual bool doupdate(HDC hDC, int tw, int th); //Does nothing here - overloaded to create views
	static void donextaction(); //Executes the next action in the stack
	virtual bool addaction(int priority); //Adds a timestep action to the list
};

#endif